#property copyright "Metatrader4 Code by jjk2. Based on MBA Thesisfrom Simon Fraser University written by C.E. ALDEA."
#property link      ""
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int Count_Bars=1000;
extern int Stochastic_KPeriod=9;
extern int Stochastic_DPeriod=6;
extern int Stochastic_SlowPeriod=2;
extern int Momentum_Period=9;
extern int RSI_Period=9;
extern double flat_distance=0.5;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double Formula[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {
//---- indicator drawing
  IndicatorBuffers(5);
  SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(1,ExtMapBuffer3); SetIndexStyle(1,DRAW_HISTOGRAM);
  SetIndexBuffer(2,ExtMapBuffer4); SetIndexStyle(2,DRAW_HISTOGRAM);

  SetIndexBuffer(3,ExtMapBuffer2);
  SetIndexBuffer(4,Formula);


///-----Name of Indicator
  string short_name = "ZigZag BETA    Current value calculated byindicator:";
  IndicatorShortName(short_name);

//----
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
 {
//----

//----
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int pos=0;
  if (Count_Bars>Bars) {pos=Bars;}else{pos=Count_Bars;}
  int temp=pos;
  while(pos>=0)
   {

        //string xxx = "pos";

        double Stoch = iStochastic(NULL,0,Stochastic_KPeriod,Stochastic_DPeriod,Stochastic_SlowPeriod,MODE_SMA,1,0,pos);
        double RSI = iRSI(NULL,0,RSI_Period,PRICE_CLOSE,pos);
        double moment = (iMomentum(NULL,0,Momentum_Period,PRICE_CLOSE,pos));

        //Main Forumla
        //double preFormula = (/Momentum);
        if (moment != 0)
        // ExtMapBuffer2[pos] = Stoch*(RSI)/moment;
          ExtMapBuffer2[pos] = Stoch*(RSI)/moment;
        //Alert("MACD: ", MACD," ","Stoch: ", Stoch," ", "RSI: ",RSI," ","Momentum: ", momentum," ","Volume: ", Volu);

        //Alert(Stoch*(RSI)/Roc);

        pos--;
    }

        while (temp >=0) {
         ExtMapBuffer1[temp]=EMPTY_VALUE;
         ExtMapBuffer3[temp]=EMPTY_VALUE;
         ExtMapBuffer4[temp]=EMPTY_VALUE;
         Formula[temp] =iMAOnArray(ExtMapBuffer2,0,2,0,MODE_SMA,temp);
         if (Formula[temp]-Formula[temp+1]>flat_distance){
           ExtMapBuffer1[temp] = Formula[temp];
         }else if (Formula[temp+1]-Formula[temp]>flat_distance){
           ExtMapBuffer3[temp] = Formula[temp];
         }else{
           ExtMapBuffer4[temp] = Formula[temp];
         }
         
         temp--; }
//----
  return(0);
 }
//+------------------------------------------------------------------+